diff --git a/usr.bin/w/w.c b/usr.bin/w/w.c
index f2da6485a74..2db79121e4a 100644
--- a/usr.bin/w/w.c
+++ b/usr.bin/w/w.c
@@ -137,11 +137,12 @@ main(int argc, char *argv[])
 	struct kinfo_proc *dkp;
 	struct stat *stp;
 	time_t touched;
-	int ch, i, nentries, nusers, wcmd, longidle, longattime;
+	int tenv, ch, i, nentries, nusers, wcmd, longidle, longattime;
 	const char *memf, *nlistf, *p, *save_p;
 	char *x_suffix;
 	char buf[MAXHOSTNAMELEN], errbuf[_POSIX2_LINE_MAX];
 	char fn[MAXHOSTNAMELEN];
+	char *colenv;
 	char *dot;
 
 	(void)setlocale(LC_ALL, "");
@@ -315,6 +316,10 @@ main(int argc, char *argv[])
 	       ttywidth = 79;
         else
 	       ttywidth = ws.ws_col - 1;
+  if ((colenv = getenv("COLUMN")) != NULL)
+      if ((tenv = atoi(colenv)) > 0)
+             ttywidth = tenv;
+
 	argwidth = ttywidth - WUSED;
 	if (argwidth < 4)
 		argwidth = 8;
